Subject: Re: [PATCH] net: ath9k: fix use-after-free in ath9k_hif_usb_rx_cb

From: Kalle Valo <[email-masked]>
Date: Fri, 06 Aug 2021 12:06:17 +0300

Pavel Skripkin <[email-masked]> writes:

> Syzbot reported use-after-free Read in ath9k_hif_usb_rx_cb(). The
> problem was in incorrect htc_handle->drv_priv initialization.
>
> Probable call trace which can trigger use-after-free:
>
> ath9k_htc_probe_device()
>   /* htc_handle->drv_priv = priv; */
>   ath9k_htc_wait_for_target()      <--- Failed
>   ieee80211_free_hw()		   <--- priv pointer is freed
>
> <IRQ>
> ...
> ath9k_hif_usb_rx_cb()
>   ath9k_hif_usb_rx_stream()
>    RX_STAT_INC()		<--- htc_handle->drv_priv access
>
> In order to not add fancy protection for drv_priv we can move
> htc_handle->drv_priv initialization at the end of the
> ath9k_htc_probe_device() and add helper macro to make
> all *_STAT_* macros NULL save.
>
> Also, I made whitespaces clean ups in *_STAT_* macros definitions
> to make checkpatch.pl happy.

Separate patch for cleanups, please.

> Fixes: fb9987d0f748 ("ath9k_htc: Support for AR9271 chipset.")
> Reported-and-tested-by: [email-masked]
> Signed-off-by: Pavel Skripkin <[email-masked]>
> ---
>
> Hi, ath9k maintainer/developers!
>
> I know, that you do not like changes, that wasn't tested on real
> hardware. I really don't access to this one, so I'd like you to test it on
> real hardware piece, if you have one. At least, this patch was tested by
> syzbot [1]
>
> [1] https://syzkaller.appspot.com/bug?id=6ead44e37afb6866ac0c7dd121b4ce07cb665f60

syzbot does not equal testing on real hardware. Can someone test or
review this, please?

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches